program lab4;
uses crt, fmm;
const n = 3; h = 0.0767268768437;
type matrix = array[1..n, 1..n] of real;
var
data, res: text;
i, j: byte;
a: matrix;
b, z0: floatvector;

procedure DataRead(var f:text; var m: matrix; var u, v: floatvector);
begin
  for i:= 1 to n do begin
    if i = n then readln (f, u[i])
    else read(f, u[i]);
  end;
  for i:=1 to n do begin
    for j:=1 to n do begin
      if (i=n) and (j=n) then readln(f, m[i,j])
      else read(f, m[i,j]); end; end;
for i:=1 to n do read(f, v[i]);
end;

procedure MultMatrixVector(m: matrix; u: floatvector; var Res: floatvector);
var
  i, j: Integer;
begin
  for i := 1 to n do
  begin
    res[ i] := 0.0;
    for j := 1 to n do res[ i] := res[ i] + m[ i, j] * u[ j];
  end;
end;

procedure AddVectorVector(u,v: floatvector; var res:floatvector);
begin
  for i:= 1 to n do res[i] := u[i] + v[i];
end;

procedure MultVectorScalar(u: floatvector; k: real; var res: floatvector);
begin
  for i:=1 to n do res[i] := u[i]*k;
end;

{$F+}
procedure fun(t: float; var z, zp: floatvector);
var p: floatvector;
begin
  for i:=1 to n do p[i]:=0;
  MultMatrixVector(a, z, p);
  AddVectorVector(p, b, zp);
end;
{$F-}

procedure RK23(var z:floatvector);
var
zp, p, p1, zp23, z23: floatvector;
t: float;
begin
  p[i]:=0; zp[i]:=0; z23[i]:=0; zp23[i]:=0;
  fun(t, z0, zp);
  MultVectorScalar(zp, 2*h/3, p);
  AddVectorVector(z0, p, z23);
  fun(t, z23, zp23);
  MultVectorScalar(zp23, 3,p);
  MultVectorScalar(zp, 1, p1);
  AddVectorVector(p1, p, p);
  MultVectorScalar(p, h/4, p1);
  AddVectorVector(z0, p1, z0);
z:= z0;
end;

procedure ODESolve(var f: text);
var
k: byte; t: float;
z: floatvector;
begin
  k:=1; t:=0;
  writeln(f, k:4, t:10:5, z0[1]:10:6, z0[2]:10:6, z0[3]:10:6);
  repeat
    k:= k+1; t:=t+h; RK23(z);
    writeln(f, k:4, t:10:5, z[1]:10:6, z[2]:10:6, z[3]:10:6);
  until k>40;
end;

begin
  assign(data, 'd:\ds\spRitik\Polytech\Predmet\Math\NUMANA~1\LAB\3-2\4\data.txt');
  assign(res,  'd:\ds\spRitik\Polytech\Predmet\Math\NUMANA~1\LAB\3-2\4\res.txt');
  reset(data);
  rewrite(res);
  DataRead(data, a, z0, b);
  writeln(res);
  ODESolve(res);
  close(data);
  close(res);
end.
